#if defined _thehidden_included
  #endinput
#endif
#define _thehidden_included

#include <thehidden_const> 

#if AMXX_VERSION_NUM >= 175
    #pragma reqlib thehidden
    #if !defined AMXMODX_NOAUTOLOAD
        #pragma loadlib thehidden
    #endif
#else
    #pragma library thehidden
#endif

/**
 * Sets/gets players data.
 *
 * @param id      player index.
 * @param pd      enum PLAYER_DATA.
 * @param value   new value.
 * @return        playerdata.
 */
native th_get_playerdata(id, pd);
native th_set_playerdata(id, pd, value);

/**
 * Sets/gets globals.
 *
 * @param gi      enum GLOBAL_INFO.
 * @param value   new value.
 * @return        globalinfo.
 */
native th_get_globalinfo(gi);
native th_set_globalinfo(gi, value);

/**
 * Sets/gets game mode.
 *
 * @param value   sets new game mode.
 * @return        game mode.
 */
native th_get_gamemode();
native th_set_gamemode(value);

/**
 * Sets/gets winner.
 *
 * @param value   sets new winner.
 * @return        winner.
 */
native th_get_winner();
native th_set_winner(value);

/**
 * Gets roundtime.
 *
 * @return        roundtime.
 */
native Float:th_get_roundtime();

/**
 * Register cvar to file.
 *
 * @param name[]        Cvar name.
 * @param string[]      Cvar value.
 * @param description[] Cvar description.
 * @return              Cvar pointer.
 */
native th_register_cvar(name[], string[], description[]);

/**
 * Sets/gets teams model.
 *
 * @param team    Team id - 1/2.
 * @param model[] Model name.
 * @return        Model name.
 */
native th_get_model(team, model[]);
native th_set_model(team, model[]);

/**
 * Called when game state changes.
 *
 * @param mode        GAME_STATE.
 */
forward th_gamemode(mode);

/**
 * Called when winner is set.
 *
 * @param winner      User id.
 */
forward th_winner(winner);

#include <thehidden_stocks>
