#if defined _thehidden_stocks_included
  #endinput
#endif
#define _thehidden_stocks_included

#if !defined _thehidden_included
  #include <thehidden>
#endif

stock is_dead_body(classname[])
{
  if(equal(classname, TH_DEADBODY))
    return 1;
  return 0;
}

stock auto_exec_config(const szName[])
{
  new szFileName[32];
  new iLen = copy(szFileName, charsmax(szFileName), szName);
  if(iLen <= 4 || !equal(szFileName[iLen-4], ".cfg"))
    add(szFileName, charsmax(szFileName), ".cfg");

  new szConfigPath[96];
  get_localinfo("amxx_configsdir", szConfigPath, charsmax(szConfigPath));
  format(szConfigPath, charsmax(szConfigPath), "%s/%s", szConfigPath, szFileName);

  if(file_exists(szConfigPath))
  {
    server_cmd("exec %s", szConfigPath);
    server_exec();
    return 1;
  }

  return 0;
}

stock th_is_jailmap()
{
  static mapname[32];
  get_mapname(mapname, charsmax(mapname));

  if(equali(mapname, "jail_", 5) || equali(mapname, "jb_", 3) || equali(mapname, "jailbreak_", 10))
    return 1;

  return 0;
}

stock get_dat_deadbody(id, ent, Float:dist)
{
  if(!is_valid_ent(ent))
    return false;

  new trace = create_tr2();
  //log_amx("ENT %d, return %d", ent, get_tr2(trace, TR_pHit));

  new Float:fOrigin[2][3], origin[3];
  entity_get_vector(id, EV_VEC_origin, fOrigin[0]);
  get_user_origin(id, origin, 3);
  IVecFVec(origin, fOrigin[1]);
  if(get_distance_f(fOrigin[0], fOrigin[1]) > dist)
    return false;

  engfunc(EngFunc_TraceLine, fOrigin[0], fOrigin[1], DONT_IGNORE_MONSTERS, id, trace);
  get_tr2(trace, TR_vecEndPos, fOrigin[1]);
  engfunc(EngFunc_TraceModel, fOrigin[0], fOrigin[1], HULL_POINT, ent, trace);
  if(get_tr2(trace, TR_pHit) == ent)
  {
    free_tr2(trace);
    return true;
  }

  free_tr2(trace);
  return false;
}

stock move_grenade()
{
  new ent = -1;
  while((ent = find_ent_by_class(ent, "grenade")))
    entity_set_origin(ent, Float:{-8191.0, -8191.0, -8191.0});

  return 1;
}

stock my_register_cvar(name[], string[], description[], flags = 0, Float:fvalue = 0.0)
{
  th_register_cvar(name, string, description);
  return register_cvar(name, string, flags, fvalue);
}

stock set_client_commands(cmd[], func[])
{
  //log_amx("%s", cmd);
  static msg[32];
  formatex(msg, charsmax(msg), "say /%s", cmd);
  register_clcmd(msg, func);
  formatex(msg, charsmax(msg), "say_team /%s", cmd);
  register_clcmd(msg, func);
  formatex(msg, charsmax(msg), "th_%s", cmd);
  register_clcmd(msg, func);
}

stock strip_weapons(id)
{
  if(!is_user_alive(id))
    return;

  static const PRIMARY_WEAPONS_BIT_SUM = (1<<CSW_SCOUT)|(1<<CSW_XM1014)|(1<<CSW_MAC10)|(1<<CSW_AUG)|(1<<CSW_UMP45)|(1<<CSW_SG550)|(1<<CSW_GALIL)|(1<<CSW_FAMAS)|
    (1<<CSW_AWP)|(1<<CSW_MP5NAVY)|(1<<CSW_M249)|(1<<CSW_M3)|(1<<CSW_M4A1)|(1<<CSW_TMP)|(1<<CSW_G3SG1)|(1<<CSW_SG552)|(1<<CSW_AK47)|(1<<CSW_P90);
  static const SECONDARY_WEAPONS_BIT_SUM = (1<<CSW_P228)|(1<<CSW_ELITE)|(1<<CSW_FIVESEVEN)|(1<<CSW_USP)|(1<<CSW_GLOCK18)|(1<<CSW_DEAGLE);
  static const GRENADES_WEAPONS_BIT_SUM = (1<<CSW_HEGRENADE)|(1<<CSW_FLASHBANG)|(1<<CSW_SMOKEGRENADE)|(1<<CSW_C4);
  new weapons[32], num_weapons, index, weaponid;
  get_user_weapons(id, weapons, num_weapons);

  static wname[32];
  for (index = 0; index < num_weapons; index++)
  {
    weaponid = weapons[index];
    
    if(((1<<weaponid) & PRIMARY_WEAPONS_BIT_SUM) || ((1<<weaponid) & SECONDARY_WEAPONS_BIT_SUM) || ((1<<weaponid) & GRENADES_WEAPONS_BIT_SUM))
    {
      get_weaponname(weaponid, wname, charsmax(wname));

      ham_strip_weapon(id, wname);
      cs_set_user_bpammo(id, weaponid, 0);
    }
  }

  set_pdata_float(id, 116, 0.0); // m_fHasPrimary
  remove_user_shield(id);
}

stock ham_strip_weapon(index, const weapon[])
{
  if(!is_user_alive(index))
    return false;

  new weaponid = get_weaponid(weapon);
  if(!weaponid)
    return false;

  new weapon_ent = fm_find_ent_by_owner(-1, weapon, index);
  if (!weapon_ent)
    return false;

  new current_weapon_ent = fm_cs_get_current_weapon_ent(index);
  new current_weapon = pev_valid(current_weapon_ent) ? cs_get_weapon_id(current_weapon_ent) : -1;
  if(current_weapon == weaponid)
    ExecuteHamB(Ham_Weapon_RetireWeapon, weapon_ent);

  if (!ExecuteHamB(Ham_RemovePlayerItem, index, weapon_ent))
    return false;

  user_has_weapon(index, weaponid, 0);
  ExecuteHamB(Ham_Item_Kill, weapon_ent);
  remove_user_shield(index);
  //set_pev(index, pev_weapons, pev(index, pev_weapons) & ~(1<<weaponid));

  return true;
}

stock ham_give_weapon(id, weapon[], val = 0)
{
  if(!is_user_alive(id))
    return false;

  if(!equal(weapon, "weapon_",7)) return 0;

  new wEnt = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, weapon));
  if(!pev_valid(wEnt)) return 0;

  set_pev(wEnt, pev_spawnflags, SF_NORESPAWN);
  dllfunc(DLLFunc_Spawn, wEnt);

  if(!ExecuteHamB(Ham_AddPlayerItem, id, wEnt))
  {
    if(pev_valid(wEnt)) set_pev(wEnt, pev_flags, pev(wEnt, pev_flags) | FL_KILLME);
    return 0;
  }

  ExecuteHamB(Ham_Item_AttachToPlayer, wEnt, id);
  if(val && !is_user_bot(id))
    //ExecuteHamB(Ham_Item_Deploy, fm_find_ent_by_owner(-1, weapon, id));
    show_weapon(id, weapon);

  return wEnt;
}

stock show_weapon(id, weapon[])
{
  static msg;
  if(!msg)
    msg = get_user_msgid("CurWeapon");

  new weaponid = get_weaponid(weapon);
  if(user_has_weapon(id, weaponid))
    ExecuteHamB(Ham_Item_Deploy, fm_find_ent_by_owner(-1, weapon, id));

  engclient_cmd(id, weapon);

  emessage_begin(MSG_ONE_UNRELIABLE, msg, _, id);
  ewrite_byte(1);
  ewrite_byte(weaponid);
  ewrite_byte(-1);
  emessage_end();
}

stock fm_find_ent_by_owner(entity, const classname[], owner)
{
  while ((entity = engfunc(EngFunc_FindEntityByString, entity, "classname", classname)) && pev(entity, pev_owner) != owner) { /* keep looping */ }
  return entity;
}

stock fm_find_ent_by_class(entity, const classname[])
  return engfunc(EngFunc_FindEntityByString, entity, "classname", classname);

stock fm_cs_get_current_weapon_ent(id)
{
  if(pev_valid(id) != 2)
    return -1;

  return get_pdata_cbase(id, 373);
}

stock remove_user_shield(id)
{
  #if AMXX_VERSION_NUM >= 183
		if(get_pdata_bool(id, 2043))                //m_bHasShield
		{
			set_pdata_bool(id, 2043, false);            //m_bHasShield
			set_pdata_int(id, 116, 0);                // m_fHasPrimary
			set_pdata_bool(id, 2042, false);            // m_bUsesShield
			set_pev(id, pev_gamestate, 1);
			new iHideHUD = get_pdata_int(id, 361);          // m_iHideHUD
			if(iHideHUD & (1<<7))
				set_pdata_int(id, 361, iHideHUD & ~(1<<7));  // m_iHideHUD

			return 1;
		}
  #endif
  return -id;
}

stock cs_reset_user_maxspeed(id, Float:val = 0.0)
{
  static Float:maxspeed;
  if(!val)
  {
    switch(get_user_weapon(id))
    {
      case CSW_SG550, CSW_AWP, CSW_G3SG1: maxspeed = 210.0;
      case CSW_M249: maxspeed = 220.0;
      case CSW_AK47: maxspeed = 221.0;
      case CSW_M3, CSW_M4A1: maxspeed = 230.0;
      case CSW_SG552: maxspeed = 235.0;
      case CSW_XM1014, CSW_AUG, CSW_GALIL, CSW_FAMAS: maxspeed = 240.0;
      case CSW_P90: maxspeed = 245.0;
      case CSW_SCOUT: maxspeed = 260.0;
      default: maxspeed = 250.0;
    }
  }
  else maxspeed = val;

  #if defined _fun_included
  set_user_maxspeed(id, maxspeed);
  #else
    #if defined _engine_included
    entity_set_float(id, EV_FL_maxspeed, maxspeed);
    #else
    set_pev(id, pev_maxspeed, maxspeed);
    #endif
  #endif
}
