#include <amxmodx>
#include <fakemeta>
#include <engine>
#include <xs>
#include <thehidden>

new g_iNightVision[33], g_szLightLevel[32], g_pForwardLightStyle, g_pMsgScreenFade;
new Float:g_fWaitTime[33], g_iMaxPlayers, g_iPlayerSprites[3];

new const g_iNVColor[3] = {132, 142, 217};
new const g_iPlayerHealth[3] = {60, 40, 20};

public plugin_precache()
{
  g_pForwardLightStyle = register_forward(FM_LightStyle, "Forward_LightStyle_pre", 0);
  g_iPlayerSprites[0] = precache_model("sprites/thehidden/trace_green.spr");
  g_iPlayerSprites[1] = precache_model("sprites/thehidden/trace_blue.spr");
  g_iPlayerSprites[2] = precache_model("sprites/thehidden/trace_red.spr");
}

public plugin_init()
{
  register_plugin("[TH] Heat vision", TH_VERSION, TH_AUTHOR);
  unregister_forward(FM_LightStyle, g_pForwardLightStyle, 0);

  g_pMsgScreenFade  = get_user_msgid("ScreenFade");
  g_iMaxPlayers     = get_maxplayers();
  register_message(g_pMsgScreenFade, "Message_ScreenFade");
  register_message(get_user_msgid("NVGToggle"), "Message_NVGToggle");
}

public Forward_LightStyle_pre(style, const val[])
{
  if(!style)
    copy(g_szLightLevel, charsmax(g_szLightLevel), val);
}

public client_PostThink(id)
{
  if(!is_user_alive(id) || !g_iNightVision[id] || g_fWaitTime[id] + 0.7 > get_gametime())
    return;

  if(pev(id, pev_button))
    return;

  g_fWaitTime[id] = get_gametime();
  static Float:origin[3], sprite, health;
  for(new i = 1; i <= g_iMaxPlayers; i++)
  {
    if(is_user_alive(i))
    {
      pev(i, pev_origin, origin);
      health = get_user_health(i);
      if(health > g_iPlayerHealth[0])
        sprite = g_iPlayerSprites[0];
      else if(health > g_iPlayerHealth[1])
        sprite = g_iPlayerSprites[1];
      else sprite = g_iPlayerSprites[2];
      create_icon_origin(id, origin, sprite);
    }
  }
}

public Message_ScreenFade(msg_id, msg_dest, msg_entity)
{
  if(!g_iNightVision[msg_entity])
    return PLUGIN_CONTINUE;
  
  if(get_msg_arg_int(4) != 255 || get_msg_arg_int(5) != 255 || get_msg_arg_int(6) != 255 || get_msg_arg_int(7) < 200)
    return PLUGIN_CONTINUE;

  remove_task(msg_entity);
  set_task(get_msg_arg_int(1) / 4096.0, "task_restore_screenfade", msg_entity);

  return PLUGIN_CONTINUE;
}

public Message_NVGToggle(msg_id, msg_dest, msg_entity)
{
  new flag = get_msg_arg_int(1);

  message_begin(MSG_ONE_UNRELIABLE, SVC_LIGHTSTYLE, _, msg_entity);
  write_byte(0);
  write_string(flag ? "#" : g_szLightLevel);
  message_end();
  
  if(!task_exists(msg_entity))
  {
    message_begin(MSG_ONE_UNRELIABLE, g_pMsgScreenFade, _, msg_entity);
    write_short((1<<12));
    write_short(0);
    write_short(0x0004);
    if(flag)
    {
      write_byte(g_iNVColor[0]);
      write_byte(g_iNVColor[1]);
      write_byte(g_iNVColor[2]);
      write_byte(73);
    }
    else
    {
      write_byte(0);
      write_byte(0);
      write_byte(0);
      write_byte(0);
    }
    message_end();
  }

  g_iNightVision[msg_entity] = flag;
  return PLUGIN_HANDLED;
}

public task_restore_screenfade(id)
{
  if(!g_iNightVision[id])
    return;

  message_begin(MSG_ONE_UNRELIABLE, g_pMsgScreenFade, _, id);
  write_short((1<<12));
  write_short(0);
  write_short(0x0004);
  write_byte(g_iNVColor[0]);
  write_byte(g_iNVColor[1]);
  write_byte(g_iNVColor[2]);
  write_byte(73);
  message_end();
}

stock create_icon_origin(id, Float:origin[3], sprite) // By sontung0
{
  if(!is_in_viewcone(id, origin))
    return;

  new Float:fMyOrigin[3];
  pev(id, pev_origin, fMyOrigin);

  new Float:fMiddle[3], Float:fHitPoint[3];
  xs_vec_sub(origin, fMyOrigin, fMiddle);
  trace_line(-1, fMyOrigin, origin, fHitPoint);

  new Float:fWallOffset[3], Float:fDistanceToWall;
  fDistanceToWall = vector_distance(fMyOrigin, fHitPoint) - 10.0;
  normalize(fMiddle, fWallOffset, fDistanceToWall);

  new Float:fSpriteOffset[3];
  xs_vec_add(fWallOffset, fMyOrigin, fSpriteOffset);
  new Float:fScale, Float:fDistanceToTarget = vector_distance(fMyOrigin, origin);
  if(fDistanceToWall > 100.0)
    fScale = 8.0 * (fDistanceToWall / fDistanceToTarget);
  else fScale = 2.0;

  te_sprite(id, fSpriteOffset, sprite, floatround(fScale));
}

stock te_sprite(id, Float:origin[3], sprite, scale) // By sontung0
{  
  message_begin(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, _, id);
  write_byte(TE_SPRITE);
  write_coord(floatround(origin[0]));
  write_coord(floatround(origin[1]));
  write_coord(floatround(origin[2]));
  write_short(sprite);
  write_byte(scale);
  write_byte(125);
  message_end();
}

stock normalize(Float:fIn[3], Float:fOut[3], Float:fMul) // By sontung0
{
  new Float:fLen = xs_vec_len(fIn);
  xs_vec_copy(fIn, fOut);
  
  fOut[0] /= fLen, fOut[1] /= fLen, fOut[2] /= fLen;
  fOut[0] *= fMul, fOut[1] *= fMul, fOut[2] *= fMul;
}
