#include <amxmodx>
#include <hamsandwich>
#include <fakemeta>
#include <cstrike>
#include <amx_settings_api>
#include <thehidden>

enum _:TaskData
{
  myplaceholder,
    Float:mytime
}

new const g_szBlockZoom[][] =
{
  "weapon_aug",
  "weapon_awp",
  "weapon_g3sg1",
  "weapon_scout",
  "weapon_sg550",
  "weapon_sg552"
};

new g_pMsgSetFOV, g_pMsgScreenShake, g_pMsgScreenFade, cvar_hidden_nades, cvar_hidden_nades_radius, cvar_hidden_nades_strength;
new g_iBlockPlayer[33], g_szTinnitusSound[TH_MAXFILELENGHT], g_iNadeCount;

public plugin_precache()
{
  if(!amx_load_setting_string(TH_SETTINGSFILE, "Hidden", "SOUND_TINNITUS", g_szTinnitusSound, charsmax(g_szTinnitusSound)))
  {
    g_szTinnitusSound = "thehidden/tinnitus.wav";
    amx_save_setting_string(TH_SETTINGSFILE, "Hidden", "SOUND_TINNITUS", g_szTinnitusSound);
  }
  precache_sound(g_szTinnitusSound);
}

public plugin_init()
{
  register_plugin("[TH] Hidden nade", TH_VERSION, TH_AUTHOR);
  cvar_hidden_nades          = my_register_cvar("th_hidden_nades", "2", "Number of grenades for hidden. (Default: 2)");
  cvar_hidden_nades_radius   = my_register_cvar("th_hidden_nades_radius", "300.0", "Grenade explosion radius. (Default: 300.0)");
  cvar_hidden_nades_strength = my_register_cvar("th_hidden_nades_strength", "250.0", "Grande explosion strength. (Default: 250.0)");

  RegisterHamPlayer(Ham_TakeDamage, "Ham_TakeDamage_pre", 0);
  for(new i = 0; i < sizeof(g_szBlockZoom); i++)
    RegisterHam(Ham_Weapon_SecondaryAttack, g_szBlockZoom[i], "Ham_SecondaryAttack_pre", 0);

  g_pMsgSetFOV      = get_user_msgid("SetFOV");
  g_pMsgScreenShake = get_user_msgid("ScreenShake");
  g_pMsgScreenFade  = get_user_msgid("ScreenFade");
}

public grenade_throw(id, ent, nade)
{
  if(nade == CSW_HEGRENADE && is_user_alive(id) && th_get_playerdata(id, PD_HIDDEN))
  {
    if(g_iNadeCount > 1)
    {
      cs_set_user_bpammo(id, CSW_HEGRENADE, 2);
      g_iNadeCount--;
    }
  }
}

public th_gamemode(mode)
{
  if(mode == GAME_STARTED)
  {
    new hidden = th_get_globalinfo(GI_HIDDEN);
    if(hidden)
    {
      set_task(0.5, "delayed_game_started", hidden);
    }
    else g_iNadeCount = 0;
  }
}

public delayed_game_started(id)
{
  g_iNadeCount = get_pcvar_num(cvar_hidden_nades);
  ham_give_weapon(id, "weapon_hegrenade");
}

public Ham_TakeDamage_pre(victim, inflictor, attacker, Float:damage, damage_type)
{
  if(is_user_alive(attacker) && is_user_alive(victim))
  {
    if(damage_type & DMG_GRENADE && th_get_playerdata(attacker, PD_HIDDEN))
    {
      //log_amx("inf %d, attack %d", inflictor, attacker);

      damage /= 4.5;
      SetHamParamFloat(4, damage);
      if(damage > 1.0)
      {
        if(pev_valid(inflictor))
        {
          static Float:origin[3];
          pev(inflictor, pev_origin, origin);
          grenade_push(origin);
        }
        give_dizzy_effects(victim, damage);
      }
    }
  }
}

public Ham_SecondaryAttack_pre(ent)
{
  if(pev_valid(ent))
  {
    if(g_iBlockPlayer[pev(ent, pev_owner)])
      return HAM_SUPERCEDE;
  }

  return HAM_IGNORED;
}

give_dizzy_effects(victim, Float:damage)
{
  if(is_user_alive(victim))
  {
    new Float:time = damage/4.0;
    static Float:angles[3];
    pev(victim, pev_angles, angles);

    angles[0] += random_float(damage, damage);
    angles[1] += random_float(damage, damage);
    set_pev(victim, pev_angles, angles);

    angles[2] += random_float(damage, damage);
    set_pev(victim, pev_punchangle, angles);
    set_pev(victim, pev_fixangle, 1);

    client_cmd(victim, "spk ^"%s^"", g_szTinnitusSound);
    g_iBlockPlayer[victim] = true;
    message_begin(MSG_ONE_UNRELIABLE, g_pMsgSetFOV, _, victim);
    write_byte(180);
    message_end();

    new param[TaskData];
    param[mytime] = _:fabs((time/2.0) - 0.5);
    message_begin(MSG_ONE_UNRELIABLE, g_pMsgScreenFade, _, victim);
    write_short(FixedUnsigned16(param[mytime], 1<<12));
    write_short(0);
    write_short((SF_FADE_IN + SF_FADE_ONLYONE)); //flags (SF_FADE_IN + SF_FADE_ONLYONE) (SF_FADEOUT)
    write_byte(255);
    write_byte(0);
    write_byte(0);
    write_byte(130);
    message_end();

    set_task(fabs(time-1.0), "reset_view", victim);
    param[mytime] = _:(time/4.0);
    set_task(param[mytime], "reset_screenfade", victim, param, sizeof(param));

    message_begin(MSG_ONE_UNRELIABLE, g_pMsgScreenShake, _, victim);
    write_short(FixedUnsigned16(10.0, 1<<12)); // shake amount
    write_short(FixedUnsigned16(time, 1<<12)); // shake lasts this long
    write_short(FixedUnsigned16(5.0, 1<<8)); // shake noise frequency
    message_end();
  }
}

public reset_view(victim)
{
  g_iBlockPlayer[victim] = false;
  message_begin(MSG_ONE_UNRELIABLE, g_pMsgSetFOV, _, victim);
  write_byte(90);
  message_end();
}

public reset_screenfade(param[TaskData], victim)
{
  message_begin(MSG_ONE_UNRELIABLE, g_pMsgScreenFade, _, victim);
  write_short(FixedUnsigned16(param[mytime], 1<<12));
  write_short(0);
  write_short((0)); //flags (SF_FADE_IN + SF_FADE_ONLYONE) (SF_FADEOUT)
  write_byte(255);
  write_byte(0);
  write_byte(0);
  write_byte(130);
  message_end();
}

stock FixedUnsigned16(Float:value, scale)
{
  new output;
  output = floatround(value * scale);
  if(output < 0)
    output = 0;
  if(output > 0xFFFF)
    output = 0xFFFF;

  return output;
}

stock Float:fabs(Float:x)
{
  return x > 0.0 ? x : -x;
}

grenade_push(Float:origin[3])
{
  origin[2] -= 30.0;
  new id = -1, Float:dist, Float:speed, Float:radius = get_pcvar_float(cvar_hidden_nades_radius), Float:strength = get_pcvar_float(cvar_hidden_nades_strength);
  new Float:length;
  static Float:plOrigin[3], Float:velocity[3], Float:newvelocity[3];
  while((id = engfunc(EngFunc_FindEntityInSphere, id, origin, radius)) != 0)
  {
    if(is_user_alive(id))
    {
      pev(id, pev_origin, plOrigin);
      dist = get_distance_f(plOrigin, origin);
      speed = (1.0 - (dist / radius)) * strength;

      velocity[0] = plOrigin[0] - origin[0];
      velocity[1] = plOrigin[1] - origin[1];
      velocity[2] = plOrigin[2] - origin[2];

      length = vector_length(velocity);
      velocity[0] = (velocity[0] / length) * speed;
      velocity[1] = (velocity[1] / length) * speed;
      velocity[2] += (radius-dist);

      pev(id, pev_velocity, newvelocity);
      newvelocity[0] += velocity[0];
      newvelocity[1] += velocity[1];
      newvelocity[2] += velocity[2];
      set_pev(id, pev_velocity, newvelocity);
    }
    if(id > 32)
      break;
  }
}
