#include <amxmodx>
#include <engine>
#include <thehidden>

new g_iStatusSync, g_iHPAPSync;

public plugin_init()
{
  register_plugin("[TH] Special player info", TH_VERSION, TH_AUTHOR);

  register_event("StatusValue", "Event_StatusValue_S", "be", "1=2", "2!0");
  register_event("StatusValue", "Event_StatusValue_H", "be", "1=1", "2=0");

  g_iStatusSync = CreateHudSyncObj();
  g_iHPAPSync   = CreateHudSyncObj();
}

public client_putinserver(id)
{
  set_task(1.0, "show_status", id, _, _, "b");
}

public client_disconnect(id)
{
  if(task_exists(id))
    remove_task(id);
}

public Event_StatusValue_S(id)
{
  if(!is_user_connected(id))
    return;

  new pid = read_data(2);
  if(!th_get_playerdata(pid, PD_HIDDEN))
  {
    static name[32];
    get_user_name(pid, name, charsmax(name));

    set_hudmessage(255, 50, 0, -1.0, 0.60, 1, 0.01, 3.0, 0.01, 0.01, -1);
    ShowSyncHudMsg(id, g_iStatusSync, "%s -- [HP = %d]", name, get_user_health(pid));
  }
}

public Event_StatusValue_H(id)
{
  ClearSyncHud(id, g_iStatusSync);
}

public show_status(alive)
{
  new dead = alive;
  if(!is_user_alive(dead))
  {
    alive = entity_get_int(dead, EV_INT_iuser2);
    if(!is_user_alive(alive))
      return;
  }

  set_hudmessage(255, 50, 0, 0.02, 0.89, 0, 6.0, 1.1, 0.0, 0.0, -1);
  ShowSyncHudMsg(is_user_alive(dead) ? alive : dead, g_iHPAPSync, "[%L] --- [HP %d] --- [AP %d]", is_user_alive(dead) ? alive : dead,
  th_get_playerdata(alive, PD_HIDDEN) ? "TH_HIDDEN" : "TH_HUMAN", get_user_health(alive), get_user_armor(alive));
}
