#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
#include <engine>
#include <fun>
#include <cs_teams_api>
#include <timer_controller>
#include <thehidden>

#define TASK_ROUNDTIME          1111
#define m_flNextSecondaryAttack   47
#define m_flTimeWeaponIdle        48
#define m_flNextAttack            83
#define m_flPainShock            108
#define WEAPON_OFFSET              4
#define PLAYER_OFFSET              5

new Trie:g_tCvarsToFile, g_iTrieSize;
new Float:g_fPlayerStart, Float:g_fWallOrigin[3], Float:g_fWaitTime, Float:g_fRoundTime, Float:g_fRoundStart, Float:g_fFreezeTime, Float:g_fPlayerDot[33];
new g_pGameModeForward, g_pMsgShadowIdx, g_pPlayerAimSprite;
new g_iPlayerData[33][PLAYER_DATA], g_iGlobalInfo[GLOBAL_INFO], g_iGameMode, g_szPlayerModels[3][16];
new cvar_preparation_time, cvar_roundtime, cvar_hidden_health, cvar_hidden_visible, cvar_hidden_speed;

public plugin_precache()
  g_pPlayerAimSprite = precache_model("sprites/thehidden/laserdot.spr");

public plugin_init()
{
  register_plugin("The Hidden", TH_VERSION, TH_AUTHOR);
  register_cvar("th_server_version", TH_VERSION, FCVAR_SERVER|FCVAR_EXTDLL|FCVAR_SPONLY);

  cvar_preparation_time = mynew_register_cvar("th_preparation_time", "10", "Preparation time before game start. (Default: 10)");
  cvar_roundtime        = mynew_register_cvar("th_roundtime", "5", "Round time. (Default: 5)");
  cvar_hidden_health    = mynew_register_cvar("th_hidden_health", "500", "Hidden player health. (Default: 500)");
  cvar_hidden_visible   = mynew_register_cvar("th_hidden_visible", "7", "Hidden player visibility. (Default: 7)");
  cvar_hidden_speed     = mynew_register_cvar("th_hidden_speed", "320.0", "Hidden player movement speed. (Default: 320.0)");

  register_event("TextMsg", "Event_RestartRound", "a", "2&#Game_C", "2&#Game_w");
  register_event("HLTV", "Event_NewRound", "a", "1=0", "2=0");
  register_logevent("Event_StartRound", 2, "1=Round_Start");
  register_logevent("Event_EndRound", 2, "1=Round_End");

  new const g_szTouchWhat[][] =
  {
    "worldspawn",
    "func_wall",
    "func_breakable",
    "func_pushable"
  };

  for(new i = 0; i < sizeof(g_szTouchWhat); i++)
    register_touch(g_szTouchWhat[i], "player", "Touch_Wall");

  RegisterHamPlayer(Ham_Killed, "Ham_Killed_pre", 0);
  RegisterHamPlayer(Ham_TakeDamage, "Ham_TakeDamage_pre", 0);
  RegisterHamPlayer(Ham_TakeDamage, "Ham_TakeDamage_post", 1);
  RegisterHamPlayer(Ham_CS_Player_ResetMaxSpeed, "Ham_Player_ResetMaxSpeed_post", 1);

  RegisterHam(Ham_Weapon_SecondaryAttack, "weapon_knife", "Ham_SecondaryAttack_pre", 0);
  RegisterHam(Ham_Item_Deploy, "weapon_hegrenade", "Ham_Item_Deploy_pre", 0);
  RegisterHam(Ham_Touch, "weaponbox", "Ham_Touch_pre", 0);
  RegisterHam(Ham_Touch, "armoury_entity", "Ham_Touch_pre", 0);
  register_forward(FM_CmdStart, "Forward_CmdStart_pre", 0);
  register_forward(FM_PlayerPreThink, "Forward_PlayerPreThink_pre", 0);

  g_pGameModeForward = CreateMultiForward("th_gamemode", ET_IGNORE, FP_CELL);
  g_pMsgShadowIdx = get_user_msgid("ShadowIdx");
  register_dictionary("thehidden.txt");
}

public plugin_natives()
{
  register_library("thehidden");
  register_native("th_get_gamemode", "_get_gamemode");
  register_native("th_set_gamemode", "_set_gamemode");
  register_native("th_get_playerdata", "_get_playerdata");
  register_native("th_set_playerdata", "_set_playerdata");
  register_native("th_get_globalinfo", "_get_globalinfo");
  register_native("th_set_globalinfo", "_set_globalinfo");
  register_native("th_get_roundtime", "_get_roundtime");
  register_native("th_register_cvar", "_register_cvar");
  register_native("th_get_model", "_get_model");
  register_native("th_set_model", "_set_model");
}

public plugin_cfg()
{
  auto_exec_config(TH_CONFIGFILE);
  g_fRoundTime = get_pcvar_float(cvar_roundtime);
  TrieDestroy(g_tCvarsToFile);
}

public client_disconnect(id)
{
  if(get_player_data(id, PD_HIDDEN))
  {
    new num;
    static players[32];
    get_players(players, num);

    if(num)
    {
      set_user_hidden(id, false, true);
      cs_set_player_team(players[random(num)], CS_TEAM_T);
      th_set_winner(2);
    }
  }

  if(id == get_global_info(GI_NEXTHIDDEN))
    set_global_info(GI_NEXTHIDDEN, false);

  reset_user_one(id);
}

public client_putinserver(id)
{
  reset_user_one(id);
  set_task(11.0, "startup_info", id);
}

public startup_info(id)
{
  // Please don't remove this :)
  client_print_color(id, print_team_default, "%s Mod created by ^3%s^1, ^4skype:guskis1^1, version: ^3%s^1!", TH_TAG, TH_AUTHOR, TH_VERSION);
}

public Event_RestartRound()
{
  if(get_game_mode() != GAME_RESTARTING)
  {
    set_user_hidden(get_global_info(GI_HIDDEN), false, false);
    reset_user_all();
    reset_global_info();
    set_global_info(GI_NEXTHIDDEN, 0);
    set_game_mode(GAME_RESTARTING);
  }
}

public Event_EndRound()
{
  if(get_game_mode() != GAME_ENDED)
  {
    set_game_mode(GAME_ENDED);
  }
}

public Event_NewRound()
{
  if(get_game_mode() != GAME_PREPARING)
  {
    set_user_hidden(get_global_info(GI_HIDDEN), false, false);
    new cvar = get_pcvar_num(cvar_preparation_time);
    if(!cvar) set_pcvar_num(cvar_preparation_time, cvar = 1);
    g_fFreezeTime = float(cvar);
    set_task(0.1, "set_timer");

    g_fRoundTime = get_pcvar_float(cvar_roundtime);
    g_fRoundStart = get_gametime();
    reset_user_all();
    reset_global_info();

    set_game_mode(GAME_PREPARING);
  }
}

public set_timer()
  RoundTimerSet(0, get_pcvar_num(cvar_preparation_time));

public Event_StartRound()
{
  if(task_exists(TASK_ROUNDTIME))
    remove_task(TASK_ROUNDTIME);

  set_task(get_pcvar_float(cvar_preparation_time), "do_the_magic", TASK_ROUNDTIME);
}

public do_the_magic()
{
  RoundTimerSet(floatround(g_fRoundTime));

  new num, id;
  static players[32];
  get_players(players, num, "a");

  if(num)
  {
    if(!get_global_info(GI_NEXTHIDDEN))
    {
      id = players[random(num)];
      set_user_hidden(id, true, true);
    }
    else
    {
      set_user_hidden(get_global_info(GI_NEXTHIDDEN), true, true);
      set_global_info(GI_NEXTHIDDEN, false);
    }

    for(--num; num >= 0; num--)
    {
      id = players[num];

      if(get_player_data(id, PD_HIDDEN))
        cs_set_player_team(id, CS_TEAM_T);
      else cs_set_player_team(id, CS_TEAM_CT);
    }
    set_game_mode(GAME_STARTED);
  }
  else set_game_mode(GAME_OFF);
}

public Touch_Wall(ent, id)
{
  if(get_game_mode() != GAME_STARTED)
    return;

  if(!is_user_connected(ent) && is_user_alive(id) && get_player_data(id, PD_HIDDEN))
  {
    static Float:origin[3];
    pev(id, pev_origin, origin);
    if(get_distance_f(origin, g_fWallOrigin) >= 5.0)
    {
      g_fWallOrigin = origin;
      set_player_data(id, PD_JUMPING, false);
    }
  }
}

public Ham_Touch_pre(ent, id)
{
  if(get_game_mode() != GAME_STARTED)
    return HAM_IGNORED;

  if(pev_valid(ent) && is_user_alive(id) && get_player_data(id, PD_HIDDEN))
    return HAM_SUPERCEDE;

  return HAM_IGNORED;
}

public Ham_Killed_pre(victim, killer, shouldgib)
{
  if(get_game_mode() != GAME_STARTED)
    return;

  if(killer != victim)
  {
    if(is_user_connected(victim) && get_player_data(victim, PD_HIDDEN))
    {
      set_user_hidden(victim, false, true);
      if(is_user_connected(killer))
        set_global_info(GI_NEXTHIDDEN, killer);
    }

    //if(get_player_data(killer, PD_HIDDEN))
    //{
    //}

    if(is_user_connected(killer) && is_user_connected(victim))
    {
      static name[32];
      get_user_name(victim, name, charsmax(name));
      client_print_color(killer, print_team_red, "%s %L", TH_TAG, killer, "TH_HIDDEN_KILLER", name);
      get_user_name(killer, name, charsmax(name));
      client_print_color(victim, print_team_red, "%s %L", TH_TAG, victim, "TH_HIDDEN_VICTIM", name);
    }
  }
}

public Ham_TakeDamage_pre(victim, inflictor, attacker, Float:damage, damage_type)
{
  if(get_game_mode() != GAME_STARTED)
    return HAM_IGNORED;

  if(is_user_connected(victim) && get_player_data(victim, PD_HIDDEN))
  {
    if(damage_type & DMG_FALL)
      return HAM_SUPERCEDE;
  }

  if(get_pcvar_num(get_cvar_pointer("mp_friendlyfire")))
  {
    if(is_user_connected(attacker) && is_user_connected(victim))
    {
      if(victim != attacker && cs_get_user_team(victim) == cs_get_user_team(attacker) && !(damage_type & DMG_GRENADE))
      {
        SetHamParamEntity(1, attacker);
        return HAM_HANDLED;
      }
    }
  }

  if(is_user_connected(attacker) && get_player_data(attacker, PD_HIDDEN))
  {
    if(get_user_weapon(attacker) == CSW_KNIFE && attacker == inflictor)
    {
      if(damage > 60.0)
        ExecuteHam(Ham_TakeDamage, victim, attacker, attacker, 300.0, (1<<2)+(1<<13));
      else
      {
        new maxhealth = get_pcvar_num(cvar_hidden_health);
        new health = get_user_health(attacker) + floatround(damage);
        if(health <= maxhealth)
          set_user_health(attacker, health);
        else set_user_health(attacker, maxhealth);
      }
    }
  }

  return HAM_IGNORED;
}

public Ham_TakeDamage_post(victim, inflictor, attacker, Float:damage, damage_type)
{
  if(get_game_mode() != GAME_STARTED)
    return;

  if(is_user_connected(victim) && get_player_data(victim, PD_HIDDEN))
    set_pdata_float(victim, m_flPainShock, 1.0, PLAYER_OFFSET);
  if(is_user_connected(attacker) && is_user_connected(victim))
  {
    if(cs_get_user_team(victim) == cs_get_user_team(attacker) && victim != attacker)
      set_pdata_float(attacker, m_flPainShock, 1.0, PLAYER_OFFSET);
  }
}

public Ham_SecondaryAttack_pre(ent)
{
  if(get_game_mode() != GAME_STARTED)
    return HAM_IGNORED;

  if(!pev_valid(ent))
    return HAM_IGNORED;

  new id = pev(ent, pev_owner);
  if(!is_user_alive(id) || !get_player_data(id, PD_HIDDEN))
    return HAM_IGNORED;

  send_anim(id, ent, 4);
  set_pdata_float(id, m_flNextAttack, get_gametime(), PLAYER_OFFSET);
  set_pdata_float(id, m_flNextSecondaryAttack, get_gametime(), PLAYER_OFFSET);
  set_player_data(id, PD_DELAYED, ent);
  set_task(1.45, "delay_attack", ent);

  return HAM_SUPERCEDE;
}

stock send_anim(id, ent, anim)
{
  #if AMXX_VERSION_NUM < 183
    set_pev(id, pev_weaponanim, anim);
    message_begin(MSG_ONE, SVC_WEAPONANIM, {0, 0, 0}, id);
    write_byte(anim);
    write_byte(pev(id, pev_body));
    message_end();
    return ent;
  #else
    ExecuteHam(Ham_CS_Weapon_SendWeaponAnim, ent, anim, 1);
    return id;
  #endif
}

public Ham_Player_ResetMaxSpeed_post(id)
{
  if(!is_user_alive(id) || !get_player_data(id, PD_HIDDEN))
    return;

  cs_reset_user_maxspeed(id, get_pcvar_float(cvar_hidden_speed));
}

public Ham_Item_Deploy_pre(ent)
{
  if(get_game_mode() != GAME_STARTED)
    return HAM_IGNORED;

  if(!pev_valid(ent))
    return HAM_IGNORED;

  new id = pev(ent, pev_owner);
  if(!is_user_alive(id) || !get_player_data(id, PD_HIDDEN))
    return HAM_IGNORED;

  new task = get_player_data(id, PD_DELAYED);
  if(task)
  {
    if(task_exists(task))
      remove_task(task);
  }

  return HAM_HANDLED;
}

public delay_attack(ent)
{
  if(!pev_valid(ent))
    return;

  new id = pev(ent, pev_owner);
  if(!is_user_connected(id))
    return;

  set_player_data(id, PD_DELAYED, false);
  set_pdata_float(id, m_flNextAttack, 0.0, PLAYER_OFFSET);
  set_pdata_float(id, m_flNextSecondaryAttack, 0.0, PLAYER_OFFSET);
  ExecuteHam(Ham_Weapon_SecondaryAttack, ent);
  send_anim(id, ent, 0);
}

public Forward_PlayerPreThink_pre(id)
{
  if(!get_game_mode() || !is_user_alive(id) || get_player_data(id, PD_HIDDEN) || g_fPlayerDot[id] > get_gametime())
    return;

  new weap = get_user_weapon(id);
  if(weap == CSW_KNIFE || weap == CSW_HEGRENADE || weap == CSW_SMOKEGRENADE || weap == CSW_FLASHBANG || weap == CSW_C4)
    return;

  g_fPlayerDot[id] = get_gametime() + 0.07;
  static origin[3];
  get_user_origin(id, origin, 3);
  show_dot(origin);
}

stock show_dot(origin[3])
{
  message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
  write_byte(TE_SPRITE);
  write_coord(origin[0]);
  write_coord(origin[1]);
  write_coord(origin[2]);
  write_short(g_pPlayerAimSprite);
  write_byte(4);
  write_byte(255);
  message_end();
}

public Forward_CmdStart_pre(id)
{
  if(!is_user_alive(id) || !get_player_data(id, PD_HIDDEN) || get_game_mode() != GAME_STARTED)
    return;

  new button = pev(id, pev_button), oldbuttons = pev(id, pev_oldbuttons), flags = pev(id, pev_flags);
  if(button_check(button) && !button_check(oldbuttons))
    g_fPlayerStart = get_gametime();

  if(!(flags & FL_ONGROUND))
  {
    static Float:origin[3];
    static Float:oldOrigin[3];
    pev(id, pev_origin, origin);
    if(get_distance_f(origin, g_fWallOrigin) < 5.0)
    {
      if(button && !button_check(button) && (button != IN_SCORE) && (button != IN_ATTACK) && (button != IN_ATTACK2))
        set_player_data(id, PD_ONWALL, false);
      else
      {
        if(!get_player_data(id, PD_ONWALL))
        {
          oldOrigin = origin;
          set_player_data(id, PD_ONWALL, true);
        }

        static Float:velocity[3];
        velocity_by_aim(id, 0, velocity);
        set_pev(id, pev_velocity, velocity);

        if(!get_player_data(id, PD_JUMPING))
        {
          if(get_distance_f(origin, oldOrigin) <= 10.0)
            engfunc(EngFunc_SetOrigin, id, oldOrigin);
        }
      }
    }
    else set_player_data(id, PD_ONWALL, false);
  }

  if(!button_check(button) && button_check(oldbuttons) && g_fWaitTime < get_gametime())
  {
    g_fWaitTime = get_gametime() + 0.5;
    if(flags & FL_ONGROUND || get_player_data(id, PD_ONWALL))
    {
      new Float:time = get_gametime() - g_fPlayerStart;
      if(time < 0.6)
        time = 0.6;
      else if(time > 1.0)
        time = 1.0;

      static Float:velocity[3];
      velocity_by_aim(id, floatround(550+100*time), velocity);
      if(pev(id, pev_movetype) == MOVETYPE_FLY && !(pev(id, pev_button) & IN_JUMP))
        client_cmd(id, "+jump;wait;-jump");
      set_player_data(id, PD_JUMPING, true);
      set_pev(id, pev_velocity, velocity);
    }
  }

  if(pev(id, pev_fuser2))
    set_pev(id, pev_fuser2, 0.0);
}

stock get_game_mode()
  return g_iGameMode;

stock set_game_mode(value)
{
  if(g_iGameMode && value == GAME_RESTARTING)
    log_amx("[TH] Game has restarted :(");

  g_iGameMode = value;
  new ret;
  ExecuteForward(g_pGameModeForward, ret, value);
}

stock get_player_data(id, pd)
  return g_iPlayerData[id][pd];

stock set_player_data(id, pd, value)
  g_iPlayerData[id][pd] = value;

stock get_global_info(gi)
  return g_iGlobalInfo[gi];

stock set_global_info(gi, value)
  g_iGlobalInfo[gi] = value;

stock reset_user_all()
{
  new num, id;
  static players[32];
  get_players(players, num);

  for(--num; num >= 0; num--)
  {
    id = players[num];
    reset_user_one(id);
  }
}

stock reset_user_one(id)
{
  new task = get_player_data(id, PD_DELAYED);
  if(task)
  {
    if(task_exists(task))
      remove_task(task);
  }
    
  for(new i = 0; i < PLAYER_DATA; i++)
    set_player_data(id, i, false);

  if(task_exists(id))
    remove_task(id);
}

stock reset_global_info()
{
  if(task_exists(TASK_ROUNDTIME))
    remove_task(TASK_ROUNDTIME);

  for(new i = 0; i < GLOBAL_INFO; i++)
  {
    if(i == GI_NEXTHIDDEN) continue;
    set_global_info(i, false);
  }
}

Float:get_roundtime()
  return get_gametime() - g_fRoundStart - g_fFreezeTime;

stock button_check(button)
{
  if(button & IN_ALT1 || button & IN_RELOAD)
    return 1;

  return 0;
}

stock set_user_hidden(id, value, print = 0)
{
  if(is_user_connected(id))
  {
    set_player_data(id, PD_HIDDEN, value);
    set_global_info(GI_HIDDEN, value ? id : 0);

    if(value)
    {
      strip_weapons(id);
      ExecuteHam(Ham_CS_RoundRespawn, id);
      ExecuteHamB(Ham_Item_Deploy, find_ent_by_owner(-1, "weapon_knife", id));
      set_user_health(id, get_pcvar_num(cvar_hidden_health));
      set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, get_pcvar_num(cvar_hidden_visible));
      set_user_footsteps(id, 1);
      cs_reset_user_maxspeed(id, get_pcvar_float(cvar_hidden_speed));
      cs_set_user_nvg(id, 1);
      cs_reset_user_model(id);
      cs_set_user_model(id, g_szPlayerModels[1]);

      player_shadow(id);
      menu_cancel(id);
      show_menu(id, 0, "^n", 1);
    }
    else
    {
      set_user_rendering(id);
      set_user_footsteps(id, 0);
      if(is_user_alive(id))
      {
        if(get_user_health(id) > 100)
          set_user_health(id, 100);
        ExecuteHam(Ham_Item_Deploy, find_ent_by_owner(-1, "weapon_knife", id));
        cs_reset_user_maxspeed(id);
        cs_set_user_nvg(id, 0);
      }
    }

    if(print)
    {
      static name[32];
      get_user_name(id, name, charsmax(name));
      client_print_color(0, print_team_red, "%s %L", TH_TAG, LANG_PLAYER, value ? "TH_HIDDEN_NEW" : "TH_HIDDEN_DEAD", name);
    }
  }
}
  
stock mynew_register_cvar(name[], string[], description[], flags = 0, Float:fvalue = 0.0)
{
  new_register_cvar(name, string, description);
  return register_cvar(name, string, flags, fvalue);
}

stock new_register_cvar(name[], string[], description[], plug[] = "th_main.amxx")
{
  static path[96];
  if(!path[0])
  {
    get_localinfo("amxx_configsdir", path, charsmax(path));
    format(path, charsmax(path), "%s/%s", path, TH_CONFIGFILE);
  }

  new file;
  if(!g_tCvarsToFile)
    g_tCvarsToFile = TrieCreate();

  if(!file_exists(path))
  {
    file = fopen(path, "wt");
    if(!file)
      return 0;

    fprintf(file, "// Server specific.^n");
    fprintf(file, "%-32s %-8s // %-32s // %s^n", "mp_tkpunish", "0",        plug, "Disables TeamKill punishments");
    fprintf(file, "%-32s %-8s // %-32s // %s^n", "mp_friendlyfire", "0",      plug, "Enables friendly fire to attack teamnates");
    fprintf(file, "%-32s %-8s // %-32s // %s^n", "mp_limitteams", "0",        plug, "Disables team limits");
    fprintf(file, "%-32s %-8s // %-32s // %s^n", "mp_autoteambalance", "0",      plug, "Disables team limits");
    fprintf(file, "%-32s %-8s // %-32s // %s^n", "mp_freezetime", "0",        plug, "Disables freeze time on round start");
    fprintf(file, "%-32s %-8s // %-32s // %s^n", "mp_playerid", "2",        plug, "Disables team info when aiming on player");
    fprintf(file, "%-32s %-8s // %-32s // %s^n", "sv_alltalk", "1",        plug, "Enables alltalk");
    fprintf(file, "%-26s %-14s // %-32s // %s^n", "amx_statscfg", "off PlayerName",  plug, "Disables player name when aiming on player");
    fprintf(file, "^n");
    fprintf(file, "// Mod specific.^n");
  }
  else
  {
    file = fopen(path, "rt");
    if(!file)
      return 0;

    //if(!TrieGetSize(g_tCvarsToFile))
    if(!g_iTrieSize)
    {
      new newline[48];
      static line[128];
      while(!feof(file))
      {
        fgets(file, line, charsmax(line));
        if(line[0] == ';' || !line[0])
          continue;

        parse(line, newline, charsmax(newline));
        remove_quotes(newline);
        #if AMXX_VERSION_NUM >= 183
          TrieSetCell(g_tCvarsToFile, newline, 1, false);
        #else
          TrieSetCell(g_tCvarsToFile, newline, 1);
        #endif
        g_iTrieSize++;
      }
    }
    fclose(file);
    file = fopen(path, "at");
  }

  if(!TrieKeyExists(g_tCvarsToFile, name))
  {
    fprintf(file, "%-32s %-8s // %-32s // %s^n", name, string, plug, description);
    #if AMXX_VERSION_NUM >= 183
      TrieSetCell(g_tCvarsToFile, name, 1, false);
    #else
      TrieSetCell(g_tCvarsToFile, name, 1);
    #endif
    g_iTrieSize++;
  }

  fclose(file);
  return 1;
}

stock player_shadow(id)
{
  new num, i;
  static players[32];
  get_players(players, num, "a");

  for(--num; num >= 0; num--)
  {
    i = players[num];
    if(i != id)
    {
      message_begin(MSG_ONE_UNRELIABLE, g_pMsgShadowIdx, _, i);
      write_long(0);
      message_end();
    }
  }
}

// API
public _get_playerdata(plugin, params)
{
  if(params != 2)
    return -1;

  return get_player_data(get_param(1), get_param(2));
}

public _set_playerdata(plugin, params)
{
  if(params != 3)
    return -1;

  set_player_data(get_param(1), get_param(2), get_param(3));
  return 1;
}

public _get_globalinfo(plugin, params)
{
  if(params != 1)
    return -1;

  return get_global_info(get_param(1));
}

public _set_globalinfo(plugin, params)
{
  if(params != 2)
    return -1;

  set_global_info(get_param(1), get_param(2));
  return 1;
}

public _get_gamemode()
  return get_game_mode();

public _set_gamemode(plugin, params)
{
  if(params != 1)
    return -1;

  set_game_mode(get_param(1));
  return get_param(1);
}

public Float:_get_roundtime()
  return get_roundtime();

public _register_cvar(plugin, params)
{
	if(params != 3)
		return -1;

	static name[48], string[16], pluginname[48], description[128];
	get_string(1, name, charsmax(name));
	get_string(2, string, charsmax(string));
	get_string(3, description, charsmax(description));
	get_plugin(plugin, pluginname, charsmax(pluginname));

	return new_register_cvar(name, string, description, pluginname);
}

public _get_model(plugin, params)
{
  if(params != 2)
    return -1;

  new id = get_param(1);
  set_string(2, g_szPlayerModels[id], charsmax(g_szPlayerModels[]));

  return 1;
}

public _set_model(plugin, params)
{
  if(params != 2)
    return -1;

  new id = get_param(1);
  get_string(2, g_szPlayerModels[id], charsmax(g_szPlayerModels[]));

  return 1;
}
