#include <amxmodx>
#include <cstrike>
#include <fakemeta>
#include <hamsandwich>
#include <thehidden>

new const g_szPriWeapGive[][] =
{
  "weapon_ak47",
  "weapon_m4a1",
  "weapon_awp",
  "weapon_m3"
};

new const g_szPriWeapName[][] =
{
  "CV-47",
  "M4A1",
  "Magnum",
  "12 Gauge"
};

new const g_iPriWeapAmmo[] =
{
  90,
  90,
  30,
  32
};

new const g_szSecWeapGive[][] =
{
  "weapon_usp",
  "weapon_glock18",
  "weapon_elite",
  "weapon_deagle"
};

new const g_szSecWeapName[][] =
{
  "K&M .45",
  "9X19mm",
  ".40 Dual",
  "Night Hawk"
};

new const g_iSecWeapAmmo[] =
{
  100,
  120,
  120,
  35
};

new g_iPlayerWeaps[33], g_iRememberWeap[33][3];

public plugin_init()
{
  register_plugin("[TH] Weapons menu", TH_VERSION, TH_AUTHOR);
  set_client_commands("guns", "reset_weapon_menu");
}

public th_gamemode(mode)
{
  if(mode == GAME_STARTED || mode == GAME_RESTARTING)
  {
    new num, id;
    static players[32];
    get_players(players, num);
    for(--num; num >= 0; num--)
    {
      id = players[num];
      if(mode == GAME_RESTARTING)
        g_iPlayerWeaps[id] = false;
      else if(is_user_alive(id))
      {
        g_iPlayerWeaps[id] = false;
        strip_weapons(id);
        if(!g_iRememberWeap[id][0])
          show_weapon_menu(id);
        else
        {
          if(!th_get_playerdata(id, PD_HIDDEN))
          {
            give_weapons(id, 1, g_iRememberWeap[id][1]);
            give_weapons(id, 2, g_iRememberWeap[id][2]);
          }
        }
      }
    }
  }
}

public show_weapon_menu(id)
{
  if(is_user_alive(id) && !th_get_playerdata(id, PD_HIDDEN))
  {
    static menu, option[64], data[3];
    menu = menu_create("Weapon menu", "show_weapon_menu_handle");

    menu_cancel(id);
    show_menu(id, 0, "^n", 1);
    if(!g_iPlayerWeaps[id])
    {
      for(new i = 0; i < sizeof(g_szPriWeapName); i++)
      {
        formatex(option, charsmax(option), "%s", g_szPriWeapName[i]);
        num_to_str(i, data, charsmax(data));
        menu_additem(menu, option, data, 0);
      }
    }
    else
    {
      for(new i = 0; i < sizeof(g_szSecWeapName); i++)
      {
        formatex(option, charsmax(option), "%s", g_szSecWeapName[i]);
        num_to_str(i, data, charsmax(data));
        menu_additem(menu, option, data, 0);
      }
    }

    formatex(option, charsmax(option), "%s[%s]", "Remember weap", g_iRememberWeap[id][0] ? "ON" : "OFF");
    menu_additem(menu, option, "10", 0);
    menu_display(id, menu);
  }
}

public show_weapon_menu_handle(id, menu, item)
{
  if(item == MENU_EXIT || !is_user_alive(id) || th_get_playerdata(id, PD_HIDDEN))
  {
    menu_destroy(menu);
    return PLUGIN_HANDLED;
  }

  new access, callback, num[3];
  menu_item_getinfo(menu, item, access, num, charsmax(num), _, _, callback);
  menu_destroy(menu);

  new pick = str_to_num(num);
  if(pick == 10)
  {
    g_iRememberWeap[id][0] = !g_iRememberWeap[id][0];
    client_print_color(id, print_team_default, "%s %L", TH_TAG, id, g_iRememberWeap[id][0] ? "TH_WEAPON_WRITE" : "TH_WEAPON_RESET");
    show_weapon_menu(id);
  }
  else
  {
    if(!g_iPlayerWeaps[id])
    {
      g_iPlayerWeaps[id] = true;
      show_weapon_menu(id);
      g_iRememberWeap[id][1] = pick;
      give_weapons(id, 1, pick);
    }
    else
    {
      g_iPlayerWeaps[id] = false;
      g_iRememberWeap[id][2] = pick;
      give_weapons(id, 2, pick);
    }
  }

  return PLUGIN_HANDLED;
}

public reset_weapon_menu(id)
{
  g_iRememberWeap[id][0] = false;
  g_iRememberWeap[id][1] = false;
  g_iRememberWeap[id][2] = false;
  client_print_color(id, print_team_default, "%s %L", TH_TAG, id, "TH_WEAPON_RESET");
}

public give_weapons(id, type, pick)
{
  if(type == 1)
  {
    ham_give_weapon(id, g_szPriWeapGive[pick]);
    cs_set_user_bpammo(id, get_weaponid(g_szPriWeapGive[pick]), g_iPriWeapAmmo[pick]);
  }
  else if(type == 2)
  {
    ham_give_weapon(id, g_szSecWeapGive[pick]);
    cs_set_user_bpammo(id, get_weaponid(g_szSecWeapGive[pick]), g_iSecWeapAmmo[pick]);
  }
}
